import es, popuplib, cfglib, gamethread, path, sqlite3

info = es.AddonInfo()
info.name     = "SIC-Tracers"
info.version  = "0.1"
info.url      = "None"
info.basename = "sic_tracers"
info.author   = "sicman_adrian"
es.ServerVar('sic_tracers', info.version, 'Bullet Tracers').makepublic()

config = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + '/cfg/tracers.cfg')
config.text("********************")
config.text("    SIC-Tracers     ")
config.text("********************")
tracers_defaultcolor   = config.cvar("tracers_defaultcolor",   'Red', "Default Color * First letter Capital*")
tracer_command   = config.cvar("tracer_command",   '!tracer', "What players type to change there color")
tracers_duration   = config.cvar("tracers_duration",   1.0, "Duration tracer stays")

config.write()

color_dict = {'Red':(255.0,0.0,0.0),'Light Red':(255.0,75.0,52.0),'Yellow':(255.0,255.0,0.0),'Green':(0.0,255.0,0.0),'Light Green':(75.0,255.0,75.0),'Blue':(0.0,0.0,255.0),'Light Blue':(75.0,75.0,255.0),'Aqua':(0.0,255.0,255.0),'Pink':(255.0,0.0,255.0),'Purple':(155.0,0.0,255.0), 'Orange':(255.0,155.0,0.0),'White':(255.0,255.0,255.0)}

# BIG BIG BIG BIG BIG BIG THANKS TO DANIELB,OJII,ASH FOR THE SQLITE/CLASS HELP
class player:
    def __init__(self, steamid):
        self.steamid = steamid
    def setColor(self, choice):
        if choice in color_dict:
            cursor.execute("INSERT OR REPLACE INTO tracerdata (steamid, color) VALUES ('%s','%s')" % (self.steamid,choice))

player_dict = {}

addonDir = path.path(es.getAddonPath('tracer'))
pathCheck = addonDir.joinpath('database.sqlite')
connection = sqlite3.connect(pathCheck)
cursor = connection.cursor() 

def load():
    global sic_colormenu
    sic_colormenu = popuplib.easymenu('sic_colormenu', '_popup_choice', color_menuselect)
    sic_colormenu.settitle('Tracers Colors')
    colors = ('Red', 'Yellow', 'Green', 'Blue',
        'Aqua', 'Purple', 'Pink', 'Orange','White','Light Red','Light Green','Light Blue') 
    for c in colors:
        sic_colormenu.addoption(c, c)
    es.doblock('corelib/noisy_on')
    config.execute()
    if not es.exists('command', str(tracer_command)):
        es.regsaycmd(str(tracer_command), 'tracer/popup')
    cursor.execute("CREATE TABLE IF NOT EXISTS tracerdata (steamid TEXT PRIMARY KEY, color TEXT DEFAULT '%s')" % tracers_defaultcolor)

def unload():
    es.doblock('corelib/noisy_off')
    popuplib.delete('sic_colormenu') 
    if es.exists('command', str(tracer_command)):
        es.unregsaycmd(str(tracer_command))
    connection.commit()
    cursor.close()
    connection.close()

def es_map_start(ev):
    connection.commit()

def popup():
    userid = es.getcmduserid()
    if popuplib.active(userid)['name'] != '0':
        popuplib.close(popuplib.active(userid)['name'], userid)
    sendpopup(userid)

def sendpopup(userid):
    popuplib.send('sic_colormenu', userid) 

def color_menuselect (userid, choice, popupid):
    player_dict[es.getplayersteamid(userid)].setColor(choice)
    es.tell(userid, '#multi','#green[SIC-Tracers] #defaultYour tracer color is now %s' % choice)

def round_start(ev):
    es.msg('#multi','#green[SIC-Tracers] #default Type !tracer to bring up color menu')

def player_disconnect(ev):
    del player_dict[ev['es_steamid']]

def player_activate(ev):
    player_dict[ev['es_steamid']] = player(ev['es_steamid'])
    cursor.execute("INSERT OR IGNORE INTO tracerdata (steamid) VALUES ('%s')" % ev['es_steamid'])
    cursor.execute('SELECT color FROM tracerdata WHERE steamid="%s"'% ev['es_steamid'])
    choice = cursor.fetchone()
    player_dict[ev['es_steamid']].setColor(choice)

def bullet_impact(ev):
    myX,myY,myZ = es.getplayerlocation(ev['userid'])
    if es.getplayerprop(ev['userid'],'CBasePlayer.localdata.m_Local.m_bDucked'):
        myZ += 44
    else:
        myZ += 64
    # Players location
    vector1 = '%s,%s,%s' % (myX,myY,myZ)
    # Bullet Impact location
    vector2 = '%s,%s,%s' % (ev['x'],ev['y'],ev['z'])
    # Create a beam
    model = es.precachemodel('materials/sprites/laser.vmt')
    model1 = es.precachemodel('materials/sprites/halo01.vmt')
    cursor.execute("SELECT color FROM tracerdata WHERE steamid='%s'" % ev['es_steamid'])
    data = cursor.fetchone()
    red,green,blue = color_dict[dataReturn(data)]
    es.effect('beam', vector1, vector2, model, model1, 0, 0, int(tracers_duration), 5, 10, 0, 0, red, green, blue, 255, 30)

def dataReturn(data):
    if not data:
        return data
    if len(data) == 1:
        return data[0]
    return data